# Copyright The Numerical Algorithms Group Limited 1992-94.
#
# This awk program is used to create the main ht file for the users
# guide (without examples). The input arguments are the ugXX.htex
# files making up the users guide.  Standard output contains the ht
# page.

BEGIN                   {
        print "% Copyright The Numerical Algorithms Group Limited 1992-94. All rights reserved."
        print "% !! DO NOT MODIFY THIS FILE BY HAND !! Created by chapmenu.awk."
        comsep = "% ====================================================================="
        print comsep
        print "\\begin{page}{UsersGuidePage}{Users Guide}"
        print comsep
        print "This is the table of contents for the Users Guide."
        print "Click on any item below to see that section."
        print "\\beginscroll"
        print "\\indent{3}"
        print "\\beginmenu"
        inChap = 0
        chapNum = 0
}

/^\\head{chapter}/      {
        chapterHandler($0,16,"")
        next
}

/^\\headTODO{chapter}/      {
        chapterHandler($0,20,"\\bf ")
        next
}

# otherwise
                {
        next
}

END                     {
        print "\\menudownlink{{G. Glossary}}{GlossaryPage}"
        print "\\endmenu"
        print "\\indent{0}"
        print "\\endscroll"
        print "\\autobuttons"
        print "\\end{page}"
}

function chapterHandler(line,prefLen,font) {
        chapNum = 0 + substr(FILENAME,3,2)
        # extract title
        line = substr(line,prefLen)            # skip prefix
        et = index(line,"}{")
        if (et == 0)
          printf "%! ERROR: badly formed \\head form.\n"
        else {
          title = substr(line,1,et-1)
          label = substr(line,et+2,length(line)-et-2)
          if (chapNum == 1)
                partHandler("Part I.   Basic Features of \\Language{}")
          else if (chapNum == 8)
                partHandler("Part II.  Advanced Problem Solving and Examples")
          else if (chapNum == 10)
                partHandler("Part III. Advanced Programming in \\Language{}")
          else if (chapNum == 16)
                partHandler("Appendices.")

          if (chapNum < 16)
                chap = chapNum""
          else
                chap = substr("ABCDEFGHIJKLMNOPQRSTUVWXYZ",chapNum-15,1)
          printf("\\menudownlink{{%s%s. %s}}{%sPage}\n",font,chap,title,label)
          # add the entry for the generated chapter 9
          if (chapNum == 8) {
            print "\\menudownlink{{9. Some Examples for Domains and Packages}}{ExamplesExposedPage}"
          }
        }
}

function partHandler(part) {
        print "\\endmenu"
        print "\\indent{0}"
        print part
        print "\\indent{3}"
        print "\\beginmenu"
}
