# Copyright The Numerical Algorithms Group Limited 1992-94.
#
# This processes the gloss.ht file (usually in /spad/src/doc/hypertex/pages)
# and produces a tex file for inclusion in the user's guide.

BEGIN   {
        print "% Copyright The Numerical Algorithms Group Limited 1992-94. All rights reserved."
        print "%"
        print "% DO NOT EDIT THIS FILE. This was created by gloss.awk"
        print "% from gloss.ht."
        print "%"
        print "\\chapter*{Glossary}\n"
        word = ""
}

# kill page start up stuff
(NR == 1)       {
        $0 = substr($0,66)
}

# see if we are finished
/^\\endmenu/    {
        exit
}

# see if we are starting an item
/^\\item/       {
        # line starts like "\item\newline{\em \menuitemstyle{}}\tab{0}{\em "
        $0 = substr($0,48)
        # line ends like "}\space{}"
        $0 = substr($0,1,length($0) - 9)
        # we now have the glossary item name
        if (NR > 1) {
          # fix up if punctuation
          if (index(".+-=<>,\'?",substr(word,1,1)) > 0)
            word = word " @\\begingroup \\string\\tt{} " word " \\endgroup"
          printf "\\index{%s}\n",word
          print "\\end{tabular}\n\n\\noindent"
        }
        print "\\begin{tabular}{p{1in}p{4.72in}}"
        printf "{\\tt %s} &\n",$0
        word = $0
        next
}

# must be in the middle of something
                {
        gsub(/\\spadsyscom/,"\\spadsys")
        gsub(/\\centerline/,"\\htcenter")
        gsub(/\\newline/," ")

        # do some line breaking

        numwords = split($0,words," ")
        w = 0
        for (i = 1; i <= numwords; i++) {
          lw = length(words[i])
          if (w + lw > 72) {
            printf "\n%s",words[i]
            w = lw
          }
          else {
            printf "%s%s",(w > 0 ? " " : ""),words[i]

            # newline at end of sentence?

            if ("." == substr(words[i],lw,1)) {
              printf "\n"
              w = 0
            }
            else
              w += 1 + lw
          }
        }
        if (w > 0)
          printf "\n"
        next
}

END     {
        printf "\\index{%s}\n",word
        print "\\end{tabular}"
}
