# Create the text of the AXIOM book chapter for examples of domains and
# packages.

# Argument 1 (required):  xmp.list   (usually in /spad/src/doc/htex)
# Argument 2 (optional):  name of directory (with trailing /)
#                         in which to get the example tex files

# The text goes to standard output.

BEGIN   {
        dir = ""
        if (ARGC > 2) {
          dir = ARGV[2]
          if (substr(dir,length(dir),1) != "/")
            dir = dir"/"
          ARGC = 2
        }
        print "% Copyright The Numerical Algorithms Group Limited 1992-94. All rights reserved."
        print "% !! DO NOT MODIFY THIS FILE BY HAND !! Created by xmpchap.awk"
        print "% ====================================================================="
        print "\\setcounter{chapter}{8} % Chapter 9"
        print "%"
        print "\\chapter{Some Examples of Domains and Packages}\\label{ExamplesExposed}"
        print "%"
        print "In this chapter we show examples of many of the most commonly"
        print "used \\Language{} domains and packages."
        print "The sections are organized by constructor names."
        print "%"
        upper = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
}

# abbr name
        {
        printf "\\head{section}{%s}{%sXmp}\n",hyphen($2),$2
        printf "\\exptypeindex{%s}\n",$2
        printf "\\input{%s%s}\n",dir,$1
        print "%"
}

# add discretionary hyphens to constructor names
function hyphen(name,  i,newname,c) {
        newname = substr(name,1,1)
        for (i = 2; i <= length(name); i++) {
          c = substr(name,i,1)
          if (index(upper,c)) {
            newname = newname"\\-"
          }
          newname = newname c
        }
        return newname
}
